<template>
    <div class="analitika-analitika">
        <div class="analitika__a--left">
            <a class="link-one link__a-left" :class="categoryClass('deposits')" @click.prevent="setCategory('deposits')">
                <svg>
                    <use xlink:href="/img/sprite.svg#briefcase"></use>
                </svg>
                <span class="link__aLeft--deposit">
                    {{ $t('analytics.charts.deposits_sum') }}
                    <span class="podSpan">
                        {{ deposits_sum }}
                    </span>
                </span>
                <span class="icon-absolute">
                    <svg><use xlink:href="/img/sprite.svg#more-button-interface-symbol-of-three-horizontal-aligned-dots"/></svg>
                </span>
            </a>
            <a class="link-one link__a-left" :class="categoryClass('refills')" @click.prevent="setCategory('refills')">
                <svg>
                    <use xlink:href="/img/sprite.svg#credit-card"></use>
                </svg>
                <span class="link__aLeft--deposit">
                    {{ $t('analytics.charts.refills_sum') }}
                    <span class="podSpan">
                        {{ refills_sum }}
                    </span>
                </span>
                <span class="icon-absolute">
                    <svg><use xlink:href="/img/sprite.svg#more-button-interface-symbol-of-three-horizontal-aligned-dots"/></svg>
                </span>
            </a>
            <a class="link-one link__a-left" :class="categoryClass('withdraws')" @click.prevent="setCategory('withdraws')">
                <svg>
                    <use xlink:href="/img/sprite.svg#coin"></use>
                </svg>
                <span class="link__aLeft--deposit">
                    {{ $t('analytics.charts.withdraws_sum') }}
                    <span class="podSpan">
                        {{ withdraws_sum }}
                    </span>
                </span>
                <span class="icon-absolute">
                    <svg><use xlink:href="/img/sprite.svg#more-button-interface-symbol-of-three-horizontal-aligned-dots"/></svg>
                </span>
            </a>
        </div>
        <div class="bar-one analitika__a--right" >
            <div class="text-top">
                <p class="text__top--left">График </p>
                <div class="box-svg">
                    <svg class="oneIcon" :class="activeTypeClass('bar')" @click="selectType('bar')">
                        <use xlink:href="/img/sprite.svg#stats"></use>
                    </svg>
                    <svg class="oneIcon" :class="activeTypeClass('line')" @click="selectType('line')">
                        <use xlink:href="/img/sprite.svg#chart"></use>
                    </svg>
                </div>
            </div>
            <line-chart :is_currency="true" range="days" :chart_data="chart_data" style="height: 400px" :options="lineOptions" v-if="type === 'line'"></line-chart>
            <bar-chart :is_currency="true" range="days" :chart_data="chart_data" style="height: 400px" :options="options" v-else-if="type === 'bar'"></bar-chart>
        </div>
    </div>
</template>

<script>
    import currencies from "../../currencies";
    import _ from 'lodash';
    import LineChart from "../charts/LineChart";
    import BarChart from "../charts/BarChart";

	export default {
		name: "AnalyticsCharts",
        props: ['analytics', 'options'],
        data(){
		    return {
		        category: 'deposits',
                type: 'line',
            }
        },
        computed: {
		    categories(){
		        return ['deposits', 'refills', 'withdraws'];
            },
            deposits_sum(){
		        return currencies.formatInDefault(this.analytics.deposits_sum);
            },
            refills_sum(){
		        return currencies.formatInDefault(this.analytics.refills_sum);
            },
            withdraws_sum(){
		        return currencies.formatInDefault(this.analytics.withdraws_sum);
            },
            chart_data(){
                if(!this.analytics.hasOwnProperty(this.category)){
                    console.log('time not exist');
                    return [];
                }
                return _.map(this.analytics[this.category], (value, key) => {
                    return [key, value];
                });
            },
			lineOptions(){
		    	return _.merge(this.options, {
		    		xAxis: {
		    			type: 'category',
						axisLabel: {
							formatter: (value) => {
								return value;
							},
						}
						//splitNumber: 12,
					}
				})
			}
        },
        methods: {
		    setCategory(category){
		        this.category = category;
            },
            categoryClass(category){
		        return {
		            'link__aLeft--active': category === this.category
                };
            },
            activeTypeClass(type){
                return {
                    'oneIcon--active': this.type === type
                }
            },
            selectType(type){
                this.type = type;
            }
        },
        components: {
		    LineChart,
            BarChart
        }
    }
</script>

<style scoped>
    .link__a-left{
        cursor: pointer;
    }
</style>
